"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const macroable_1 = require("macroable");
const utils_1 = require("@poppinss/utils");
const Route_1 = require("./Route");
class BriskRoute extends macroable_1.Macroable {
    constructor(_pattern, _globalMatchers) {
        super();
        this._pattern = _pattern;
        this._globalMatchers = _globalMatchers;
        this._invokedBy = '';
        this.route = null;
    }
    setHandler(handler, invokedBy, methods) {
        if (this.route) {
            throw new utils_1.Exception(`\`Route.${invokedBy}\` and \`${this._invokedBy}\` cannot be called together`, 500, 'E_MULTIPLE_BRISK_HANDLERS');
        }
        this.route = new Route_1.Route(this._pattern, methods || ['GET'], handler, this._globalMatchers);
        this._invokedBy = invokedBy;
        return this.route;
    }
}
exports.BriskRoute = BriskRoute;
BriskRoute._macros = {};
BriskRoute._getters = {};
