"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class Hooks {
    constructor() {
        this._hooks = {
            before: [],
            after: [],
        };
    }
    before(cb) {
        this._hooks.before.push(cb);
        return this;
    }
    after(cb) {
        this._hooks.after.push(cb);
        return this;
    }
    async executeBefore(ctx) {
        for (let hook of this._hooks.before) {
            await hook(ctx);
            if (ctx.response.hasLazyBody || !ctx.response.isPending) {
                return true;
            }
        }
        return false;
    }
    async executeAfter(ctx) {
        for (let hook of this._hooks.after) {
            await hook(ctx);
        }
    }
    commit() {
        if (this._hooks.before.length === 0) {
            this.executeBefore = async () => false;
        }
        if (this._hooks.after.length === 0) {
            this.executeAfter = async () => { };
        }
    }
}
exports.Hooks = Hooks;
